import{s as oe,o as ie,n as ee}from"../chunks/scheduler.9f522b10.js";import{S as ae,i as se,g as v,s as m,r as h,A as le,h as T,f as a,c as p,j as M,u,k as H,y as A,a as d,v as _,d as $,t as k,w as b,x as V}from"../chunks/index.192f26f8.js";import{D as X}from"../chunks/Docstring.0dd54f5a.js";import{T as ce,M as ne}from"../chunks/TokenizersLanguageContent.585b569a.js";import{H as R,E as de}from"../chunks/EditOnGithub.6d5e7de4.js";function me(x){let n,i,e,o,l,z,y="Trainer capable of training a BPE model",P,f,W,g,w,r,s,N="Trainer capable of training a Unigram model",S,C,j,L,B,Y,D,te="Trainer capable of training a WorldLevel model",G,q,O,U,E,Z,I,re="Trainer capable of training a WordPiece model",F;return n=new R({props:{title:"BpeTrainer",local:"tokenizers.trainers.BpeTrainer",headingTag:"h2"}}),o=new X({props:{name:"class tokenizers.trainers.BpeTrainer",anchor:"tokenizers.trainers.BpeTrainer",parameters:"",parametersDescription:[{anchor:"tokenizers.trainers.BpeTrainer.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the final vocabulary, including all tokens and alphabet.`,name:"vocab_size"},{anchor:"tokenizers.trainers.BpeTrainer.min_frequency",description:`<strong>min_frequency</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The minimum frequency a pair should have in order to be merged.`,name:"min_frequency"},{anchor:"tokenizers.trainers.BpeTrainer.show_progress",description:`<strong>show_progress</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to show progress bars while training.`,name:"show_progress"},{anchor:"tokenizers.trainers.BpeTrainer.special_tokens",description:`<strong>special_tokens</strong> (<code>List[Union[str, AddedToken]]</code>, <em>optional</em>) &#x2014;
A list of special tokens the model should know of.`,name:"special_tokens"},{anchor:"tokenizers.trainers.BpeTrainer.limit_alphabet",description:`<strong>limit_alphabet</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum different characters to keep in the alphabet.`,name:"limit_alphabet"},{anchor:"tokenizers.trainers.BpeTrainer.initial_alphabet",description:`<strong>initial_alphabet</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of characters to include in the initial alphabet, even
if not seen in the training dataset.
If the strings contain more than one character, only the first one
is kept.`,name:"initial_alphabet"},{anchor:"tokenizers.trainers.BpeTrainer.continuing_subword_prefix",description:`<strong>continuing_subword_prefix</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A prefix to be used for every subword that is not a beginning-of-word.`,name:"continuing_subword_prefix"},{anchor:"tokenizers.trainers.BpeTrainer.end_of_word_suffix",description:`<strong>end_of_word_suffix</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A suffix to be used for every subword that is a end-of-word.`,name:"end_of_word_suffix"},{anchor:"tokenizers.trainers.BpeTrainer.max_token_length",description:`<strong>max_token_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Prevents creating tokens longer than the specified size.
This can help with reducing polluting your vocabulary with
highly repetitive tokens like <em>======</em> for wikipedia`,name:"max_token_length"}]}}),f=new R({props:{title:"UnigramTrainer",local:"tokenizers.trainers.UnigramTrainer",headingTag:"h2"}}),w=new X({props:{name:"class tokenizers.trainers.UnigramTrainer",anchor:"tokenizers.trainers.UnigramTrainer",parameters:[{name:"vocab_size",val:" = 8000"},{name:"show_progress",val:" = True"},{name:"special_tokens",val:" = []"},{name:"shrinking_factor",val:" = 0.75"},{name:"unk_token",val:" = None"},{name:"max_piece_length",val:" = 16"},{name:"n_sub_iterations",val:" = 2"}],parametersDescription:[{anchor:"tokenizers.trainers.UnigramTrainer.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>) &#x2014;
The size of the final vocabulary, including all tokens and alphabet.`,name:"vocab_size"},{anchor:"tokenizers.trainers.UnigramTrainer.show_progress",description:`<strong>show_progress</strong> (<code>bool</code>) &#x2014;
Whether to show progress bars while training.`,name:"show_progress"},{anchor:"tokenizers.trainers.UnigramTrainer.special_tokens",description:`<strong>special_tokens</strong> (<code>List[Union[str, AddedToken]]</code>) &#x2014;
A list of special tokens the model should know of.`,name:"special_tokens"},{anchor:"tokenizers.trainers.UnigramTrainer.initial_alphabet",description:`<strong>initial_alphabet</strong> (<code>List[str]</code>) &#x2014;
A list of characters to include in the initial alphabet, even
if not seen in the training dataset.
If the strings contain more than one character, only the first one
is kept.`,name:"initial_alphabet"},{anchor:"tokenizers.trainers.UnigramTrainer.shrinking_factor",description:`<strong>shrinking_factor</strong> (<code>float</code>) &#x2014;
The shrinking factor used at each step of the training to prune the
vocabulary.`,name:"shrinking_factor"},{anchor:"tokenizers.trainers.UnigramTrainer.unk_token",description:`<strong>unk_token</strong> (<code>str</code>) &#x2014;
The token used for out-of-vocabulary tokens.`,name:"unk_token"},{anchor:"tokenizers.trainers.UnigramTrainer.max_piece_length",description:`<strong>max_piece_length</strong> (<code>int</code>) &#x2014;
The maximum length of a given token.`,name:"max_piece_length"},{anchor:"tokenizers.trainers.UnigramTrainer.n_sub_iterations",description:`<strong>n_sub_iterations</strong> (<code>int</code>) &#x2014;
The number of iterations of the EM algorithm to perform before
pruning the vocabulary.`,name:"n_sub_iterations"}]}}),C=new R({props:{title:"WordLevelTrainer",local:"tokenizers.trainers.WordLevelTrainer",headingTag:"h2"}}),B=new X({props:{name:"class tokenizers.trainers.WordLevelTrainer",anchor:"tokenizers.trainers.WordLevelTrainer",parameters:"",parametersDescription:[{anchor:"tokenizers.trainers.WordLevelTrainer.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the final vocabulary, including all tokens and alphabet.`,name:"vocab_size"},{anchor:"tokenizers.trainers.WordLevelTrainer.min_frequency",description:`<strong>min_frequency</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The minimum frequency a pair should have in order to be merged.`,name:"min_frequency"},{anchor:"tokenizers.trainers.WordLevelTrainer.show_progress",description:`<strong>show_progress</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to show progress bars while training.`,name:"show_progress"},{anchor:"tokenizers.trainers.WordLevelTrainer.special_tokens",description:`<strong>special_tokens</strong> (<code>List[Union[str, AddedToken]]</code>) &#x2014;
A list of special tokens the model should know of.`,name:"special_tokens"}]}}),q=new R({props:{title:"WordPieceTrainer",local:"tokenizers.trainers.WordPieceTrainer",headingTag:"h2"}}),E=new X({props:{name:"class tokenizers.trainers.WordPieceTrainer",anchor:"tokenizers.trainers.WordPieceTrainer",parameters:[{name:"vocab_size",val:" = 30000"},{name:"min_frequency",val:" = 0"},{name:"show_progress",val:" = True"},{name:"special_tokens",val:" = []"},{name:"limit_alphabet",val:" = None"},{name:"initial_alphabet",val:" = []"},{name:"continuing_subword_prefix",val:" = '##'"},{name:"end_of_word_suffix",val:" = None"}],parametersDescription:[{anchor:"tokenizers.trainers.WordPieceTrainer.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the final vocabulary, including all tokens and alphabet.`,name:"vocab_size"},{anchor:"tokenizers.trainers.WordPieceTrainer.min_frequency",description:`<strong>min_frequency</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The minimum frequency a pair should have in order to be merged.`,name:"min_frequency"},{anchor:"tokenizers.trainers.WordPieceTrainer.show_progress",description:`<strong>show_progress</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to show progress bars while training.`,name:"show_progress"},{anchor:"tokenizers.trainers.WordPieceTrainer.special_tokens",description:`<strong>special_tokens</strong> (<code>List[Union[str, AddedToken]]</code>, <em>optional</em>) &#x2014;
A list of special tokens the model should know of.`,name:"special_tokens"},{anchor:"tokenizers.trainers.WordPieceTrainer.limit_alphabet",description:`<strong>limit_alphabet</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum different characters to keep in the alphabet.`,name:"limit_alphabet"},{anchor:"tokenizers.trainers.WordPieceTrainer.initial_alphabet",description:`<strong>initial_alphabet</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of characters to include in the initial alphabet, even
if not seen in the training dataset.
If the strings contain more than one character, only the first one
is kept.`,name:"initial_alphabet"},{anchor:"tokenizers.trainers.WordPieceTrainer.continuing_subword_prefix",description:`<strong>continuing_subword_prefix</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A prefix to be used for every subword that is not a beginning-of-word.`,name:"continuing_subword_prefix"},{anchor:"tokenizers.trainers.WordPieceTrainer.end_of_word_suffix",description:`<strong>end_of_word_suffix</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A suffix to be used for every subword that is a end-of-word.`,name:"end_of_word_suffix"}]}}),{c(){h(n.$$.fragment),i=m(),e=v("div"),h(o.$$.fragment),l=m(),z=v("p"),z.textContent=y,P=m(),h(f.$$.fragment),W=m(),g=v("div"),h(w.$$.fragment),r=m(),s=v("p"),s.textContent=N,S=m(),h(C.$$.fragment),j=m(),L=v("div"),h(B.$$.fragment),Y=m(),D=v("p"),D.textContent=te,G=m(),h(q.$$.fragment),O=m(),U=v("div"),h(E.$$.fragment),Z=m(),I=v("p"),I.textContent=re,this.h()},l(t){u(n.$$.fragment,t),i=p(t),e=T(t,"DIV",{class:!0});var c=M(e);u(o.$$.fragment,c),l=p(c),z=T(c,"P",{"data-svelte-h":!0}),V(z)!=="svelte-1iof5l3"&&(z.textContent=y),c.forEach(a),P=p(t),u(f.$$.fragment,t),W=p(t),g=T(t,"DIV",{class:!0});var J=M(g);u(w.$$.fragment,J),r=p(J),s=T(J,"P",{"data-svelte-h":!0}),V(s)!=="svelte-ukd897"&&(s.textContent=N),J.forEach(a),S=p(t),u(C.$$.fragment,t),j=p(t),L=T(t,"DIV",{class:!0});var K=M(L);u(B.$$.fragment,K),Y=p(K),D=T(K,"P",{"data-svelte-h":!0}),V(D)!=="svelte-qhn6du"&&(D.textContent=te),K.forEach(a),G=p(t),u(q.$$.fragment,t),O=p(t),U=T(t,"DIV",{class:!0});var Q=M(U);u(E.$$.fragment,Q),Z=p(Q),I=T(Q,"P",{"data-svelte-h":!0}),V(I)!=="svelte-1yngc5g"&&(I.textContent=re),Q.forEach(a),this.h()},h(){H(e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,c){_(n,t,c),d(t,i,c),d(t,e,c),_(o,e,null),A(e,l),A(e,z),d(t,P,c),_(f,t,c),d(t,W,c),d(t,g,c),_(w,g,null),A(g,r),A(g,s),d(t,S,c),_(C,t,c),d(t,j,c),d(t,L,c),_(B,L,null),A(L,Y),A(L,D),d(t,G,c),_(q,t,c),d(t,O,c),d(t,U,c),_(E,U,null),A(U,Z),A(U,I),F=!0},p:ee,i(t){F||($(n.$$.fragment,t),$(o.$$.fragment,t),$(f.$$.fragment,t),$(w.$$.fragment,t),$(C.$$.fragment,t),$(B.$$.fragment,t),$(q.$$.fragment,t),$(E.$$.fragment,t),F=!0)},o(t){k(n.$$.fragment,t),k(o.$$.fragment,t),k(f.$$.fragment,t),k(w.$$.fragment,t),k(C.$$.fragment,t),k(B.$$.fragment,t),k(q.$$.fragment,t),k(E.$$.fragment,t),F=!1},d(t){t&&(a(i),a(e),a(P),a(W),a(g),a(S),a(j),a(L),a(G),a(O),a(U)),b(n,t),b(o),b(f,t),b(w),b(C,t),b(B),b(q,t),b(E)}}}function pe(x){let n,i;return n=new ne({props:{$$slots:{default:[me]},$$scope:{ctx:x}}}),{c(){h(n.$$.fragment)},l(e){u(n.$$.fragment,e)},m(e,o){_(n,e,o),i=!0},p(e,o){const l={};o&2&&(l.$$scope={dirty:o,ctx:e}),n.$set(l)},i(e){i||($(n.$$.fragment,e),i=!0)},o(e){k(n.$$.fragment,e),i=!1},d(e){b(n,e)}}}function fe(x){let n,i='The Rust API Reference is available directly on the <a href="https://docs.rs/tokenizers/latest/tokenizers/" rel="nofollow">Docs.rs</a> website.';return{c(){n=v("p"),n.innerHTML=i},l(e){n=T(e,"P",{"data-svelte-h":!0}),V(n)!=="svelte-4ytcyb"&&(n.innerHTML=i)},m(e,o){d(e,n,o)},p:ee,d(e){e&&a(n)}}}function ge(x){let n,i;return n=new ne({props:{$$slots:{default:[fe]},$$scope:{ctx:x}}}),{c(){h(n.$$.fragment)},l(e){u(n.$$.fragment,e)},m(e,o){_(n,e,o),i=!0},p(e,o){const l={};o&2&&(l.$$scope={dirty:o,ctx:e}),n.$set(l)},i(e){i||($(n.$$.fragment,e),i=!0)},o(e){k(n.$$.fragment,e),i=!1},d(e){b(n,e)}}}function he(x){let n,i="The node API has not been documented yet.";return{c(){n=v("p"),n.textContent=i},l(e){n=T(e,"P",{"data-svelte-h":!0}),V(n)!=="svelte-1mrchm6"&&(n.textContent=i)},m(e,o){d(e,n,o)},p:ee,d(e){e&&a(n)}}}function ue(x){let n,i;return n=new ne({props:{$$slots:{default:[he]},$$scope:{ctx:x}}}),{c(){h(n.$$.fragment)},l(e){u(n.$$.fragment,e)},m(e,o){_(n,e,o),i=!0},p(e,o){const l={};o&2&&(l.$$scope={dirty:o,ctx:e}),n.$set(l)},i(e){i||($(n.$$.fragment,e),i=!0)},o(e){k(n.$$.fragment,e),i=!1},d(e){b(n,e)}}}function _e(x){let n,i,e,o,l,z,y,P,f,W,g,w;return l=new R({props:{title:"Trainers",local:"trainers",headingTag:"h1"}}),y=new ce({props:{python:!0,rust:!0,node:!0,$$slots:{node:[ue],rust:[ge],python:[pe]},$$scope:{ctx:x}}}),f=new de({props:{source:"https://github.com/huggingface/tokenizers/blob/main/docs/source-doc-builder/api/trainers.mdx"}}),{c(){n=v("meta"),i=m(),e=v("p"),o=m(),h(l.$$.fragment),z=m(),h(y.$$.fragment),P=m(),h(f.$$.fragment),W=m(),g=v("p"),this.h()},l(r){const s=le("svelte-u9bgzb",document.head);n=T(s,"META",{name:!0,content:!0}),s.forEach(a),i=p(r),e=T(r,"P",{}),M(e).forEach(a),o=p(r),u(l.$$.fragment,r),z=p(r),u(y.$$.fragment,r),P=p(r),u(f.$$.fragment,r),W=p(r),g=T(r,"P",{}),M(g).forEach(a),this.h()},h(){H(n,"name","hf:doc:metadata"),H(n,"content",$e)},m(r,s){A(document.head,n),d(r,i,s),d(r,e,s),d(r,o,s),_(l,r,s),d(r,z,s),_(y,r,s),d(r,P,s),_(f,r,s),d(r,W,s),d(r,g,s),w=!0},p(r,[s]){const N={};s&2&&(N.$$scope={dirty:s,ctx:r}),y.$set(N)},i(r){w||($(l.$$.fragment,r),$(y.$$.fragment,r),$(f.$$.fragment,r),w=!0)},o(r){k(l.$$.fragment,r),k(y.$$.fragment,r),k(f.$$.fragment,r),w=!1},d(r){r&&(a(i),a(e),a(o),a(z),a(P),a(W),a(g)),a(n),b(l,r),b(y,r),b(f,r)}}}const $e='{"title":"Trainers","local":"trainers","sections":[{"title":"BpeTrainer","local":"tokenizers.trainers.BpeTrainer","sections":[],"depth":2},{"title":"UnigramTrainer","local":"tokenizers.trainers.UnigramTrainer","sections":[],"depth":2},{"title":"WordLevelTrainer","local":"tokenizers.trainers.WordLevelTrainer","sections":[],"depth":2},{"title":"WordPieceTrainer","local":"tokenizers.trainers.WordPieceTrainer","sections":[],"depth":2}],"depth":1}';function ke(x){return ie(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ze extends ae{constructor(n){super(),se(this,n,ke,_e,oe,{})}}export{ze as component};
